/*********************************************
 *  Biblioteca para Classe Controle Serial   *
 *  HexAvoider                               *
 *  Jose Lu                                  *
 *********************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <fcntl.h>
#include <errno.h>
#include <termios.h>

#ifndef SERIAL_H_
#define SERIAL_H_

#define PORTA_SERIAL  "/dev/ttyUSB0"   //define a porta serial a ser utilizado
#define BAUD_RATE     9600             //define a taxa de transmissão da porta serial
#define BUFFER_TAM    255              //define o tamanho do buffer de leitura


/*
 * Classe para Controle Serial
 */
class Serial {
	
	private:
		struct termios old_tio;        //armazena a configuração antiga da porta serial
		struct termios new_tio;        //armazena a configuração nova da porta serial
		int fd;                        //fd - file descriptor, descritor do arquivo para porta serial
//		char *buffer_IN;               //buffer resultado da leitura do conteúdo da porta serial
//		char *buffer_OUT;              //buffer do conteúdo a ser enviado pela porta serial
		
	public:
		Serial();                      //constructor da Classe
		int  open_port();              //estabelece a conexao com a porta serial
		int  close_port();             //fecha a porta serial
		int  write_port(char *buffer); //escreve o conteúdo do buffer na porta serial
		int  read_port(char *buffer);  //lê os dados da porta serial		
		~Serial();                     //destructor da Classe

};




#endif /*SERIAL_H_*/
